#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* HomePath="/nfs/home/q/qingz_hu";

const unsigned int MaxNodeNumber=32;
const unsigned int MaxTesterChoice=4;
const unsigned int MaxRenderChoice=28;
const unsigned int MaxScriptNumber=MaxTesterChoice*MaxRenderChoice;
const unsigned int MinTesterChoice=2;
const unsigned int MinRenderChoice=1;

const unsigned int TermNumber=6;
const unsigned int TesterChoice[MaxTesterChoice]=
{
	2,4,8,16
};

enum TermEnum
{
	MI=0, RS=1, RC=2, TS=3, TC=4, DI=5
};

const char* TermName[TermNumber]=
{
	"MasterIndex",   //MI
	"RenderHostStartIndex",  //RS
	"RenderCount",           //RC
	"TesterHostStartIndex",
	"TesterCount",
	"DisplayerIndex"
};

void processData(char* dir)
{
	FILE* stream, *result;
	char buffer[256];
	char fileName[256];
	unsigned int tester, render;
	char* ptr;
	float fps;
	for (int expand=1; expand<=6; expand++)
	{
		sprintf(fileName, "./expand%u.txt", expand);
		if ((result=fopen(fileName, "w"))==NULL)
		{
			printf("cannot create %s file\n", fileName);
			exit(1);
		}
		for (int t=0; t<MaxTesterChoice; t++)
		{
			for (int r=0; r<MaxRenderChoice; r++)
			{
				tester=TesterChoice[t];
				render=MinRenderChoice+r;
				if (tester+render>=31)
				{
					continue;
				}
				sprintf(fileName, "%s/expand%u/profile/T%uR%u.txt", dir, expand, tester, render);
				if ((stream=fopen(fileName, "r"))==NULL)
				{
					printf("cannot open file %s\n", fileName);
					fps=0.0;
				}
				else
				{
					for (int i=0; i<tester+render+3; i++)
					{
						fgets(buffer, 256, stream);
					}
					//printf("file [%s] read buffer [%s]\n", fileName, buffer); 
					ptr=strchr(buffer, '=');
					
					sscanf(ptr, "=%f\n", &fps);
				}
				fprintf(result, "%u  %u  %u %.2f\n", tester, render, tester+render+2, fps);
 				fclose(stream);
			}

		}
		fclose(result);
	}
}			    
				


int main(int argc, char** argv)
{
	if (argc!=2)
	{
		printf("usage: fpsSumTool.exe dir\n");
		return 0;
	}
	else
	{
		printf("begin process dir %s\n", argv[1]);
		processData(argv[1]);
	}
	return 0;
}

