#ifndef PLYMODEL_H
#define PLYMODEL_H


#include "octree.h"
#include <vector>
#include <string>

#ifndef LINUX_VERSION
#include <windows.h>
#endif

using namespace std;

const int MaxExpandNumber=8;

struct PlyModel
{
	int vNumber;//internal usage only
	int fNumber;//internal usage only
	PlyVertex* vertex;
	UIVector* triangle;
	//int vertexCount;
	//int faceCount;
	VVector maxCoord;
	VVector minCoord;
	VType maxEdge;

	//void retrievePlyData(char* dirName, Octree* octree, int expandNumber, bool toConvert);

	bool isValidTriangle(UIVector& myFace);

	void addToOctree(char* dirName, int expandNumber);

	void doAddToOctree(const char* fileName, int expandNumber);

	void addToOctree(const char* singleFileName);

	void addToOctree(char* dirName, VType width, int expandNumber=1);

	void doAddToOctree(const char* fileName, VType width, int expandNumber);

	void divideFileByFour(HANDLE vertexHandles[4], HANDLE faceHandles[4]);

	void getTriangleCenter(PlyVertex triangle[3], PlyVertex& center);

	void getMiddleVertex(PlyVertex* old1, PlyVertex* old2, PlyVertex* result);

	//void getVertexFromIndex(HANDLE vertexHandle, int index, PlyVertex& plyVertex);
	void expandModel();
	void calcLongestEdge(UIVector tri);
	bool analysis(char* buf);
	//int readFile(const char* fileName, int expandNumber);
	int doReadFile(const char* fileName);
	int convertFile(const char* fileName);
	//void readDirectory(char* dir, int expandNumber, bool toConvert=false);
	bool calcNormal(FaceStruct& faceStruct, VertexVector& vertexVector);
	//void outputTriangle(int triangleIndex);
	//bool equalVertex(int index1, int index2);
	//bool validTriangle(int triangleIndex);
	void crossProduct(VVector first, VVector second, VVector result);
	void normalize(VVector vect);

};


void mergeData(char* dirName, int expandTimes=0);
void mergeSingleFile(char* singleFileName);
void mergeData(char* dirName, VType width, int expandNumber=1);
void sortTriangle(UIVector triangle);
void sortTriangle(FaceStruct& triangle);
void retrievePlyData(char* dirName, Octree* octree, int expandNumber, bool toConvert);

#endif
