#ifndef VIEWCOLLECTOR_H
#define VIEWCOLLECTOR_H

#include "octree.h"
#include "octreeLoader.h"
#include "config.h"
#include "frustum.h"
#include <vector>
#include <queue>

typedef vector<int> OctreeNodeVector;


struct ViewCollector
{
	typedef deque<int> OctreeNodeQueue;
	static Octree*root;

	CFrustum frustum;

	OctreeNodeVector octreeNodeVector;

	static int vertexCounter, faceCounter;
	OctreeNodeSet searchSet;
	OctreeNodeQueue searchQueue;
	//static bool conservativeMode;
	static bool fullRenderMode;
	static bool hierRenderMode;


	void doCollectLeafNode(int index);//a BFS

	void collectHierLeafNode(int index);
	void collectLeafNode(VVector origin);//collect leaf nodes from near to far within capacity
	bool getStartingNodes(int index, VVector origin, OctreeNodeQueue& result);
	bool testAndAdd(int index);

	bool checkCapacity();
	void addCandidate(int index);
	void startCollecting(VVector origin);

	void initialize(Octree* theRoot){root=theRoot;}

};

#endif

